from ramda.curry import curry


@curry
def count_by(f, xs):
    """Counts the elements of a list according to how many match each value of a
key generated by the supplied function. Returns an object mapping the keys
produced by fn to the number of occurrences in the list. Note that all
keys are coerced to strings because of how JavaScript objects work.
Acts as a transducer if a transformer is given in list position"""
    acc = {}
    for x in xs:
        k = f(x)
        try:
            acc[k] += 1
        except KeyError:
            acc[k] = 1
    return acc
